/* Makro Guttmanskalierung                                                              
/* ===================                                                             
/* Dieses Makro ausfhren                                                                
/* Danach kann eine Guttmanskalierung                                             
/* mit dem Befehlsaufruf                                                                    
/*                                                                                                    
/* !gutt guttvars=varlist.                                                                     
/*                                                                                                    
/* aufgerufen werden.                                                                        
/* Die Variablen mssen mit gereiht nach                                           
/* Itemschwieirgkeiten (beginnend mit dem leichtesten)                       
/* angegeben werden.                                                                       
/*                                                                                                    
/* Beispiel:                                                                                      
/* !gutt guttvars=v309 v311 v307 v308 v310 v313 v312.                          
/* Fhrt eine Guttmanskalierung fr die angegebenen Variablen            
/* durch, wobei v309 das leichteste und v312 das schwierigste             
/* Item ist.                                                                                       
/*---------------------------------------------------------------------------------------------      

define !gutt(guttvars=!CMDEND).
set mxloop=10000.

matrix.
get datmat
/Variables=!guttvars
/missing=omit.   /* Variablen bernehmen
compute sumvect=rsum(datmat).   /* Summenscore als letzte Spalte
compute datmat={datmat,sumvect}.

compute dommat=make(ncol(datmat)-1,ncol(datmat)-1,0).  /* Dominanzmatrix
compute ib=make(ncol(datmat),ncol(datmat)-1, 0).	/* Matirx der Hufigkeiten der 1-Anzeige je Gesamtpunktewert
compute p=make(ncol(datmat),1,0).       /* Vektor der Scorehufigkeiten
compute fehl=make(ncol(datmat),ncol(datmat)-1, 0).  /* Fehlermatrix
compute zwi=make(ncol(datmat)-1,1,0).  /* Buffer
comp ges=make(1,9,0). /* Buffer

*p-vektor, ib- und Dominanzmatrix erstellen.
loop n=1 to nrow(datmat).
  compute p(datmat(n,ncol(datmat))+1,1)=p(datmat(n,ncol(datmat))+1,1)+1.
  loop i=1 to ncol(datmat)-1.
            compute ib(datmat(n,ncol(datmat))+1, i)=ib(datmat(n,ncol(datmat))+1, i)+datmat(n, i).
	do if datmat(n,i)=0.
	   loop j=1 to ncol(datmat)-1.
                  do if i<>j.
                     compute dommat(i, j)=dommat(i, j)+datmat(n, j).
                   end if.
	   end loop.	
             end if.
  end loop.
end loop.
print p /title="Score-Hufigkeiten (absolut)".
print dommat /title="Dominanzmatrix (oberes Dreieck: Inkonsistente Paare, unteres Konsistente Dreieck: Paare)".
print ib/ title="Ib-Matrix (Hufigkeiten der 1-Anzeige je Gesamtpunktewert)".
*Fehlermatrix erstellen.
loop i=2 to ncol(datmat).
	loop j=1 to  ncol(datmat)-1.
		do if j<=(i-1).
			compute fehl(i, j)=p(i,1)-ib(i, j).
		else.
			compute fehl(i, j)=ib(i, j).
		end if.
	end loop.
end loop.

* itemschwierigkeiten.
comp output=csum(ib).
loop j=1 to  ncol(datmat)-1.
  comp output(j)=output(j)/nrow(datmat).
end loop.
comp output=transpos(output).
*fehler je item (Fehler I).
comp output={output, transpos(csum(fehl))}.

*rep je item.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=1- (output(j,2)/nrow(datmat)).
end loop.
comp output={output, zwi}.

*mmr je item.
loop j=1 to  ncol(datmat)-1.
  do if output(j,1)>0.5.
	compute zwi(j,1)=output(j,1).
  else.
	compute zwi(j,1)=1-output(j,1).
  end if.
end loop.
comp output={output, zwi}.

*pi je item.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=output(j,3)-output(j,4).
end loop.
comp output={output, zwi}.

*Er je item.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=(1-output(j,4))*nrow(datmat).
end loop.
comp output={output, zwi}.

*PRE je item.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=(output(j,6)-output(j,2))/output(j,6).
end loop.
comp output={output, zwi}.


* Itemnummer.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=j.
end loop.

comp output={zwi, output}.

print output /format 'f5.3' /title="Itemanalyse" /clabels="Varindex", "Schwier.", "Fehler", "REP", "MMR", "PI", "Er", "PRE".

*empink je Item (Fehler II).
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=0.
end loop.

loop i=1 to ncol(datmat)-1.
	loop j=i+1 to ncol(datmat)-1.
			comp zwi(i, 1)=zwi(i, 1)+dommat(i, j).
			comp zwi(j, 1)=zwi(j, 1)+dommat(i, j).
	end loop.
end loop.
*print zwi.
comp outputII=zwi.

*repII je Item.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=1-(zwi(j,1)/nrow(datmat)).
end loop.
comp outputII={outputII, zwi}.
*C je Item.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=0.
end loop.

loop i=1 to ncol(datmat)-1.
	loop j=1 to ncol(datmat)-1.
		do if i >= j.
			comp zwi(j, 1)=zwi(j, 1)+dommat(i, j).
			comp zwi(i, 1)=zwi(i, 1)+dommat(i, j).

		else.
			comp zwi(i, 1)=zwi(i, 1)-dommat(i, j).
			comp zwi(j, 1)=zwi(j, 1)-dommat(i, j).
		end if.
		*print (zwi(i,1)).
	end loop.
end loop.
comp zwi=zwi/(rsum(dommat)+transpos(csum(dommat))).
comp outputII={outputII, zwi}.

* Itemnummer.
loop j=1 to  ncol(datmat)-1.
  comp zwi(j,1)=j.
end loop.

comp outputII={zwi, outputII}.

print outputII /format 'f5.3' /title="Itemanalyse" /clabels="Varindex", "FehlerII", "REP II", "C".

print /title="Hinweis:". 
print /title="Fehler, REP: Fehlerberechnung nach Goodenough/Edwards".
print /title="Fehler II, REP II: Fehlerberechnung nach Loevinger".

*Koeffizienten fr Gesamtskala.

comp ges(1,1)=msum(fehl). /* Fehler
comp ges(1,2)=1-(ges(1,1)/(nrow(datmat)*(ncol(datmat)-1))). /*Rep

loop j=1 to  ncol(datmat)-1.
  comp ges(1,3)=ges(1,3)+output(j, 5).
end loop.
comp ges(1,3)=ges(1,3)/(ncol(datmat)-1). /*MMR
comp ges(1,4)=ges(1,2)-ges(1,3).  /* PI
comp ges(1,5)=(1-ges(1,3))*nrow(datmat)*(ncol(datmat)-1). /* Fehler Randverteilung
comp ges(1,6)=(ges(1,5)-ges(1,1))/ges(1,5). /* PRE
comp maxc=msum(dommat).
comp empkon=0.
comp empink=0.
loop i=1 to ncol(datmat)-1.  /* Konsistente und inkonstistente Paare
	loop j=1 to ncol(datmat)-1.
		do if i >= j.
			comp empkon=empkon+dommat(i, j).
		else.
			comp empink=empink+dommat(i, j).
		end if.
	end loop.
end loop.
comp ges(1,7)=empink. /* Fehler nach Loevinger
comp ges(1,8)=1-(ges(1,7)/(nrow(datmat)*(ncol(datmat)-1))). /* Rep nach Loevinger
comp ges(1,9)=(empkon-empink)/maxc. /* Cliffs C
print ges /format 'f5.3' /title="Gesamtskala" /clabels= "Fehler", "REP", "MMR", "PI", "Er", "PRE", "FehlerII", "REP II", "C".

end matrix.

!enddefine.